"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@tangential/core");
var media_types_1 = require("@tangential/media-types");
var inputTypeRegistry = {};
var Model = {
    _inputTypeKey: null,
    defaultValue: null
};
var ConfigurableInputType = (function (_super) {
    __extends(ConfigurableInputType, _super);
    function ConfigurableInputType(config, key) {
        var _this = _super.call(this, config, key) || this;
        _this._inputTypeKey = _this.getInputTypeKey();
        return _this;
    }
    ConfigurableInputType.register = function (inputTypeCtor) {
        inputTypeRegistry[inputTypeCtor['TYPE_NAME']] = inputTypeCtor;
    };
    ConfigurableInputType.create = function (typeConfig, key, inputTypeKey) {
        typeConfig = typeConfig || {};
        key = key || typeConfig.$key;
        inputTypeKey = inputTypeKey || typeConfig._inputTypeKey;
        return new inputTypeRegistry[inputTypeKey](typeConfig, key);
    };
    return ConfigurableInputType;
}(media_types_1.StampedMediaType));
ConfigurableInputType.$model = core_1.ObjectUtil.assignDeep({}, media_types_1.StampedMediaType.$model, Model);
exports.ConfigurableInputType = ConfigurableInputType;

//# sourceMappingURL=configurable-input-type.js.map
